import com.haxepunk.Entity;
import com.haxepunk.Sfx;
import com.haxepunk.graphics.*;
import flash.geom.Rectangle;


/** Broken platforms fall if too much weight on them */
class Broken extends Entity {
	public var health:Int;
	public var fall: Float = 0;
	public var breakSound:Sfx;

	public function new(x:Float, y:Float, health:Int) {
		super(x, y);
		this.health = health;
		type = "solid";
		setHitbox(24,24);
		graphic = new Image("graphics/tiles.png", new Rectangle((3-health)*24, 0, 24, 24));
	}

	public override function moveCollideY(e:Entity): Bool {
		fall = 0;
		health = 0;
		type = "nothing";
		// Play animation
		var s:Spritemap = new Spritemap("graphics/crumble.png", 44, 24, finished);
		s.playFrames([0,1,2,3], 16, false);
		s.x = -10;
		graphic = s;
		// Sound
		breakSound = new Sfx("audio/bang.mp3");
		breakSound.play();
		return true;
	}

	public function finished() {
		scene.remove(this);
	}

	public override function update() {
		if(health==0) return;
		if(fall == 0) {
			var p:Player = cast collide("player", x, y-1);
			if(p!=null && p.size > health) { fall = 0.1; return; }
			// Is the player climbing us?
			p = cast scene.collideRect("player", x-1, y, 26, 24);
			if(p!=null && p.climb>0 && p.size > health) fall = 0.1;
		} else {
			fall += 0.6;
			var p:Entity = scene.collideRect("player", x-1, y-1, 26, 24);
			moveBy(0, fall, "solid");
			if(p!=null) {
				p.moveBy(0,fall,"solid");
				cast(p, Player).fall = fall;
			}
		}
	}
}
