
import com.haxepunk.Entity;
import com.haxepunk.Sfx;
import com.haxepunk.graphics.*;

// Targets doors and other switches
class Button extends Entity {
	public var mode: Int;		// once, multiple, sprung
	public var state: Int = 0;
	public var sound:Sfx;
	public var targets:Array<Entity> = [];

	public function new(x:Float, y:Float, mode:Int) {
		super(x, y);
		this.mode = mode;
		graphic = new Stamp("graphics/switch.png");
		setHitboxTo(graphic);
		this.y -= 2;
		this.x += 2;
		type = "switch";
		sound = new Sfx("audio/switch.mp3");
	}

	public override function update() {
		if(collide("player", x, y)!=null) {
			if(state == 0) {
				activate();
				state = 1;
				y += 1;
			}
		} else if(mode==1) {
			reset();
		} else if(mode==2) {
			activate();
			reset();
		}
	}

	public function link(e:Entity) {
		targets.push(e);
	}

	public function reset() {
		if(state!=0) {
			state = 0;
			y -= 1;
		}
	}

	public function activate() {
		sound.play();
		// Do stuff
		for(e in targets) {
			if(Std.is(e, Button)) cast(e, Button).reset();
			else if(Std.is(e, Broken)) cast(e, Broken).fall += 0.01;
			else if(Std.is(e, Door)) cast(e, Door).trigger();
			
		}
	}
}

